/**
 * @author Rafael Ostertag <rafael.ostertag@math.uzh.ch>
 */

/* global describe */
/* global it */
/* global expect */
/* global QfqNS */
/* global beforeAll */
/* global beforeEach */
/* global jasmine */
/* global $ */

describe("File Upload Acceptance", function () {
    'use strict';

    function prepareForm(id) {
        var $form;
        var $template = $("#" + id);

        $form = $('#myForm').empty();
        $form.append($template.text());

    }

    it("handles no previous uploaded file present", function () {
        prepareForm("fileupload_new");

        jasmine.Ajax.install();

        var bla = $('#fileupload')[0];
        var qfqForm = new QfqNS.QfqForm("myForm", "", "", "", "", "");

        $('#fileupload').trigger("change");

        jasmine.Ajax.requests.mostRecent().respondWith({
            "status": 200,
            "contentType": "application/json",
            "responseText": "{ \"status\": \"success\" }"
        });

        jasmine.Ajax.uninstall();
    });

});